/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.iminido.netty.helper;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.handler.codec.http.websocketx.TextWebSocketFrame;
import io.netty.handler.timeout.IdleState;
import io.netty.handler.timeout.IdleStateEvent;
import io.netty.util.CharsetUtil;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/**
 *
 * @author Administrator
 */
public class HeartbeatServerHandler extends ChannelInboundHandlerAdapter {
    
private final Logger log = LogManager.getLogger();
  
private static final ByteBuf HEARTBEAT_SEQUENCE = Unpooled
      .unreleasableBuffer(Unpooled.copiedBuffer("Heartbeat", CharsetUtil.UTF_8));
  
  
@Override
public void userEventTriggered(ChannelHandlerContext ctx, Object evt) throws Exception {
    if (evt instanceof IdleStateEvent) {
        IdleStateEvent event = (IdleStateEvent) evt;  
        String type = "";
        
        if (event.state() == IdleState.READER_IDLE) {
            type = "read idle";
        } else if (event.state() == IdleState.WRITER_IDLE) {
            type = "write idle";
        } else if (event.state() == IdleState.ALL_IDLE) {
            type = "all idle";
        }
        
        ctx.writeAndFlush(HEARTBEAT_SEQUENCE.duplicate()).addListener(ChannelFutureListener.CLOSE_ON_FAILURE);
                
        //ctx.channel().writeAndFlush(new TextWebSocketFrame("Heartbeat"));
        
        log.debug(ctx.channel().remoteAddress()+"超时类型：" + type);
    } else {
        super.userEventTriggered(ctx, evt);
    }
  }



}

